#include <iostream>
#include <algorithm>
#include <cmath>
using namespace std;
int main() 
{
    unsigned broj_dana,broj_pitanja,redni_broj_dana,broj_plazmi,lokalna,pojeli=0;
    cin>>broj_dana>>broj_pitanja;
    unsigned plazma_po_danu[1000000],pitanja[broj_pitanja+1];
    for(unsigned i=1;i<=broj_dana;i++)
    {
        cin>>redni_broj_dana>>broj_plazmi;
        plazma_po_danu[redni_broj_dana]=broj_plazmi;
        
    }
    for(unsigned i=1;i<=broj_pitanja;i++)
    {
        cin>>pitanja[i];
    }
    
    
    for(unsigned j=1;j<=broj_pitanja;j++)
    {
        lokalna=plazma_po_danu[1];
        if(lokalna>0)
        {
            lokalna--;
            pojeli++;
        }
        for(unsigned i=2;i<=pitanja[1];i++)
        {
            lokalna=lokalna+plazma_po_danu[i];
            if(lokalna>0)
            {
                lokalna--;
                pojeli++;
            }
        }
        cout<<pojeli<<endl;
        pojeli=0;
    }

    return 0;
}